use crate::{errors::RunError, stack::Stack};

pub fn args(memory: &mut Vec<u16>, origin_stack: &mut Option<&mut Stack>, data: &u16) {
    let origin_memory = &mut origin_stack.as_mut().expect(&format!("{}", RunError::RequestArgsInMainModule)).memory;

    if *origin_memory == *memory {
        eprintln!("{}", RunError::RequestArgsInMainModule);
        std::process::exit(2);
    }

    let quanity: u16;
    if *data == 0 {
        quanity = origin_memory.pop().expect(&format!("{}", RunError::MemoryEmpty));
    } else {
        quanity = *data;
    }

    for _ in 0..quanity {
        memory.push(origin_memory.pop().expect(&format!("{}", RunError::MemoryEmpty)));
    }
}